> ## Documentation Index
> Fetch the complete documentation index at: https://developers.squads.so/llms.txt
> Use this file to discover all available pages before exploring further.

# Prepare Arbitrary Transaction

> Prepare a custom transaction with specified instructions



## OpenAPI

````yaml POST /api/grid/v1/accounts/{address}/transactions
openapi: 3.1.0
info:
  title: Grid v1 API
  description: Grid v1 REST API for Solana-based smart account system
  contact:
    name: Grid API Support
    url: https://squads.so
    email: support@squads.so
  license:
    name: MIT
  version: 1.0.0
servers:
  - url: https://grid.squads.xyz
    description: Production server
security:
  - bearer_auth: []
tags:
  - name: accounts
    description: Smart account management operations
  - name: spending-limits
    description: Spending limit management
  - name: standing-orders
    description: Standing order operations
  - name: transactions
    description: Transaction management
  - name: trade
    description: Trade operations and management
  - name: payments
    description: Payment intent operations
  - name: passkeys
    description: Passkey management
  - name: kyc
    description: Know Your Customer operations
  - name: external-accounts
    description: External bank account management
  - name: virtual-accounts
    description: Virtual account management
  - name: auth
    description: Authentication operations
  - name: proposals
    description: Proposal management for multi-sig operations
  - name: compliance
    description: Compliance entity management and KYB/KYC operations
paths:
  /api/grid/v1/accounts/{address}/transactions:
    post:
      tags:
        - transactions
      operationId: handler
      parameters:
        - name: address
          in: path
          description: Smart account address (Solana public key)
          required: true
          schema:
            type: string
        - name: debug
          in: query
          description: Include simulation logs in response
          required: false
          schema:
            type: boolean
        - name: x-grid-environment
          in: header
          description: Solana network environment (sandbox, devnet, mainnet)
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PrepareTransactionRequestPayload'
        required: true
      responses:
        '200':
          description: Transaction prepared successfully
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/GridApiResponse_PrepareTransactionResponsePayload
        '400':
          description: Invalid transaction or parameters
        '403':
          description: Forbidden - insufficient permissions
        '404':
          description: Smart account not found
        '500':
          description: Internal server error
      security:
        - bearer_auth: []
components:
  schemas:
    PrepareTransactionRequestPayload:
      type: object
      required:
        - transaction
      properties:
        fee_config:
          oneOf:
            - type: 'null'
            - $ref: '#/components/schemas/FeeConfigV2'
        payer_address:
          type:
            - string
            - 'null'
        transaction:
          type: string
        transaction_signers:
          type: array
          items:
            type: string
    GridApiResponse_PrepareTransactionResponsePayload:
      type: object
      required:
        - data
        - metadata
      properties:
        data:
          type: object
          required:
            - transaction
          properties:
            fee:
              oneOf:
                - type: 'null'
                - $ref: '#/components/schemas/FinalizedFees'
            kms_payloads:
              type: array
              items:
                $ref: '#/components/schemas/KmsPayload'
            simulation_logs:
              type: array
              items:
                type: string
              nullable: true
            transaction:
              type: string
            transaction_signers:
              type: array
              items:
                type: string
        metadata:
          $ref: '#/components/schemas/Metadata'
    FeeConfigV2:
      type: object
      required:
        - currency
        - payer_address
      properties:
        currency:
          $ref: '#/components/schemas/Currency'
        payer_address:
          type: string
        self_managed_fees:
          type:
            - boolean
            - 'null'
    FinalizedFees:
      type: object
      required:
        - amount
        - amount_decimal
        - currency
        - sol_equivalent
      properties:
        amount:
          type: string
        amount_decimal:
          type: string
        currency:
          $ref: '#/components/schemas/Currency'
        sol_equivalent:
          $ref: '#/components/schemas/SolEquivalent'
    KmsPayload:
      type: object
      required:
        - provider
        - address
        - payload
      properties:
        address:
          type: string
        payload:
          type: string
        provider:
          $ref: '#/components/schemas/GridMPCProvider'
    Metadata:
      type: object
      required:
        - request_id
        - timestamp
      properties:
        request_id:
          type: string
        timestamp:
          type: string
          format: date-time
    Currency:
      oneOf:
        - $ref: '#/components/schemas/StandardCurrency'
        - $ref: '#/components/schemas/CustomCurrency'
    SolEquivalent:
      type: object
      required:
        - amount
        - amount_decimal
      properties:
        amount:
          type: string
        amount_decimal:
          type: string
    GridMPCProvider:
      type: string
      enum:
        - privy
        - dynamic
        - passkey
        - turnkey
        - external
    StandardCurrency:
      type: string
      enum:
        - sol
        - usdc
        - usdt
        - pyusd
        - eurc
    CustomCurrency:
      type: object
      required:
        - mint
        - decimals
      properties:
        decimals:
          type: integer
          format: int32
          minimum: 0
        mint:
          type: string
        symbol:
          type:
            - string
            - 'null'
  securitySchemes:
    bearer_auth:
      type: http
      scheme: bearer
      description: Your Grid API key from the Grid Dashboard

````